/*
 *  Copyright 2001 Adrian Thurston <adriant@ragel.ca>
 */

/*  This file is part of Aapl.
 *
 *  Aapl is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Aapl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Aapl; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef _AAPL_PARAMCHECK_H
#define _AAPL_PARAMCHECK_H

class ParameterCheck {
public:
	ParameterCheck(char *paramSpec, int argc, char **argv) :
			paramSpec(paramSpec), argc(argc), argv(argv) {
		iCurArg = 1;
		curArg = 0;
		argOffset = 0;
		state = noparam;
	}

	bool Check();

	char *parameterArg; /* The argument to the parameter. */
	char parameter;     /* The parameter matched. */
	enum { match, invalid, noparam } state;

	char *argOffset;    /* If we are reading params inside an
	                     * arg this points to the offset. */

	char *curArg;       /* Pointer to the current arg. */
	int iCurArg;        /* Index to the current arg. */

private:
	char *paramSpec;    /* Parameter spec supplied by the coder. */
	int argc;           /* Arguement data from the command line. */
	char **argv;

};

#endif /* _AAPL_PARAMCHECK_H */
